<?php
  // This file contains the settings for the digital map archive.
  // Each setting contains a name and a value and is presented in the following way:
  //   define('SETTING_NAME', 'setting value');
  // The settning names must not be changed, but the setting values are up to you to edit. All text setting values
  // must be enclosed in single quotes ('). If a setting value contais a single quote, use the \' character combination.
  // Numeric and boolean (true or false) settings should not be enclosed in single quotes.



  // *********************************************************************************************************
  //   SYSTEM SETTINGS
  // *********************************************************************************************************

  // database login information, ask your database server administrator/web hosting provider if you don't know
  // MySQL database host, usually provided by your web hosting provider
  define('DB_HOST', 'localhost');
  // MySQL user name, usually provided by your web hosting provider 
  define('DB_USERNAME', 'myDatabaseUserName');
  // MySQL password, usually provided by your web hosting provider 
  define('DB_PASSWORD', 'myDatabasePassword');
  // the name of the MySQL database where the map information is stored, usually provided by your web hosting provider
  // the database must exist prior to creation of the site
  define('DB_DATABASE_NAME', 'myDatabaseName');
  // the name of the MySQL database table where the map information is stored
  // don't change unless you want to install multiple archives in the same database
  // the database table must _not_ exist before creation of the site
  define('DB_TABLE_NAME', 'doma');

  // username and password for logging in, adding and edit maps on the site
  // change the default settings to your favorite settings
  // these settings are also used when connecting to the digital orienteering map archive webservice
  define('ADMIN_USERNAME', 'myUserName');
  define('ADMIN_PASSWORD', 'myPassword');

  // path to the map image directory, relative to this file. don't change unless you have a good reason
  // the directory is created during creation
  define('MAP_IMAGE_PATH', 'map_images');



    // *********************************************************************************************************
  //   APPEARANCE SETTINGS
  // *********************************************************************************************************

  // size and scaling of thumbnail images. don't change unless you have a good reason
  define('THUMBNAIL_WIDTH', 400);
  define('THUMBNAIL_HEIGHT', 100);
  define('THUMBNAIL_SCALE', 0.5);

  // determines which data fields that should be associated with a map
  // true shows a field, false hides a field
  define('SHOW_ORGANISER', true);
  define('SHOW_COUNTRY', true);
  define('SHOW_DISCIPLINE', true);
  define('SHOW_RELAY_LEG', true);
  define('SHOW_MAP_NAME', true);
  define('SHOW_RESULT_LIST_URL', true);
  define('SHOW_COMMENT', true);



  // *********************************************************************************************************
  //   LANGUAGE SETTINGS
  // *********************************************************************************************************

  // text strings for the site, translate these to your language if you want a localized site
  // HTML tags can be used

  // day names, semi-colon separated
  DEFINE('_DAY_NAMES', 'Sunday;Monday;Tuesday;Wednesday;Thursday;Friday;Saturday');
  // month names, semi-colon separated
  DEFINE('_MONTH_NAMES', 'January;February;March;April;May;June;July;August;September;October;November;December');

  define('_PAGE_TITLE', 'My digital orienteering map archive');
  define('_PAGE_DESCRIPTION', 'Maps, courses and routes from orienteering events I have attended.');

  DEFINE('_CAPTION', 'Welcome to my digital orienteering map archive!');
  DEFINE('_INTRO', 'On this site I will publish maps, courses and route choices from the orienteering event I have attended.');
  DEFINE('_SELECT_YEAR', 'Select year');
  DEFINE('_NO_MAPS', 'No maps are published.');
  DEFINE('_DISCLAIMER', 'Are you copyright owner of a map that should not be published here? <a href="mailto:myname@mydomain.com">Email me</a>.');
  DEFINE('_RSS_FEED', 'RSS feed');

  DEFINE('_DIGITAL_MAP_ARCHIVE', 'Digital Orienteering Map Archive');
  DEFINE('_VERSION', 'version');

  DEFINE('_ORGANISER', 'Organiser');
  DEFINE('_COUNTRY', 'Country');
  DEFINE('_DISCIPLINE', 'Discipline');
  DEFINE('_RELAY_LEG', 'Leg');
  DEFINE('_RELAY_LEG_LC', 'leg');
  DEFINE('_MAP_NAME', 'Area/map');
  DEFINE('_RESULTS', 'Results');
  DEFINE('_BACK', '&lt;&lt; Back');
  DEFINE('_PREVIOUS', 'Previous');
  DEFINE('_NEXT', 'Next');
  DEFINE('_LOGIN', 'Log in');
  DEFINE('_ADD_MAP', 'Add map');
  DEFINE('_LOGOUT', 'Log out');
  DEFINE('_EDIT_MAP', 'Edit');
  DEFINE('_VIEWS', 'views');
?>