<?php
  session_start();

  define("VERSION_NUMBER", "1.0");
  define("DOMA_SERVER", "http://www.matstroeng.se/doma/domaserver.php");
  
  include_once("config.php");
  include_once("data_access.php");
  include_once("map_class.php");

  if(!mysql_connect(DB_HOST, DB_USERNAME, DB_PASSWORD)) die("Could not connect to the database. Make sure that the DB_HOST, DB_USERNAME and DB_PASSWORD settings in config.php are correct.");
  if(!mysql_select_db(DB_DATABASE_NAME)) die("Could not select database. Make sure that the DB_DATABASE_NAME setting in config.php is correct.");
  mysql_query("SET NAMES utf8");
  mysql_query("SET CHARACTER SET utf8");

  function getRootUrl($webRootMode = true)
  {
    if($webRootMode)
      return dirname($_ENV["SCRIPT_NAME"]) ."/";
    else
      return dirname($_ENV["SCRIPT_FILENAME"]) ."/";
  }

  function getWebsiteUrl()
  {
    return dirname($_ENV["SCRIPT_URI"]);
  }

  function login($username, $password)
  {
    if(validateUser(stripslashes($username), stripslashes($password)))
    {
      $_SESSION["MAP_ARCHIVE_LOGGEDIN_". DB_TABLE_NAME] = true;
      return true;
    }
    return false;
  }

  function isLoggedIn()
  {
     return isset($_SESSION["MAP_ARCHIVE_LOGGEDIN_". DB_TABLE_NAME]);
  }

  function logout()
  {
     unset($_SESSION["MAP_ARCHIVE_LOGGEDIN_". DB_TABLE_NAME]);
  }
  
  function validateUser($username, $password)
  {
    return ($username == ADMIN_USERNAME && $password == ADMIN_PASSWORD);
  }

  function getThumbnailImage(Map $map, $webRootMode = true)
  {
    return getRootUrl($webRootMode) . MAP_IMAGE_PATH ."/". $map->ThumbnailImage;
  }

  function getMapImage(Map $map, $webRootMode = true)
  {
    return getRootUrl($webRootMode) . MAP_IMAGE_PATH ."/". $map->MapImage;
  }
  
  function databaseTableCreated()
  {
    return (@mysql_num_rows(@mysql_query('DESCRIBE '. DB_TABLE_NAME)) > 0);
  }

  function camelize($str)
  {
    return strtolower(substr($str, 0, 1)) . substr($str, 1);
  }

  function encapsulateLink($url, $html)
  {
    if($url == "")
    {
      return $html;
    }
    else
    {
      return '<a href="'. $url .'">'. $html .'</a>';
    }
  }

  function dateToLongString($d)
  {
    $dayNames = split(";", _DAY_NAMES);
    $monthNames = split(";", _MONTH_NAMES);
    return $dayNames[date("w", $d)] ." ".
           date("j", $d) ." ".
           $monthNames[date("n", $d) - 1] ." ".
           date("Y", $d);
  }

  function imageIsResizable($fileName)
  {
    $contents = file_get_contents(getWebsiteUrl() ."/image_is_resizable.php?filename=/". $fileName);
    return ($contents == "1");
  }

  function imageCreateFromGeneral($fileName)
  {

    switch(strtolower(getExtension($fileName)))
    {
      case "png":
        $image = ImageCreateFromPng($fileName);
        break;
      case "gif":
        $image = ImageCreateFromGif($fileName);
        break;
      default:
        $image = ImageCreateFromJpeg($fileName);
        break;
    }
    return $image;
  }

  function getExtension($fileName)
  {
    $pathinfo = pathinfo($fileName);
    return $pathinfo["extension"];
  }
  
  function getFilenameWithoutExtension($fileName)
  {
    return basename($fileName, getExtension($fileName));
  }

  function createThumbnail($sourceFileName, $targetFileNameWithoutExtension, $targetWidth, $targetHeight, $targetZoom = 1)
  {
    if(imageIsResizable($sourceFileName))
    {
      $sourceImage = imageCreateFromGeneral($sourceFileName);
      $targetFileName = $targetFileNameWithoutExtension .".". getExtension($sourceFileName);

      $sourceWidth = ImageSX($sourceImage);
      $sourceHeight = ImageSY($sourceImage);

      $targetImage = ImageCreateTrueColor($targetWidth, $targetHeight);

      if($targetZoom * $sourceWidth < $targetWidth) $targetZoom = $targetWidth / $sourceWidth;
      if($targetZoom * $sourceHeight < $targetHeight) $targetZoom = $targetHeight / $sourceHeight;

      $sourceClippedWidth = $targetWidth / $targetZoom;
      $sourceClippedHeight = $targetHeight / $targetZoom;
      $sourceCenterX = $sourceWidth / 2;
      $sourceCenterY = $sourceHeight / 2;

      $sourceX = $sourceCenterX - $sourceClippedWidth / 2;
      $sourceY = $sourceCenterY - $sourceClippedHeight / 2;

      ImageCopyResampled(
        $targetImage,
        $sourceImage,
        0,
        0,
        $sourceX,
        $sourceY,
        $targetWidth,
        $targetHeight,
        $sourceClippedWidth,
        $sourceClippedHeight);

      ImageDestroy($sourceImage);

      @ImageJpeg($targetImage, $targetFileName);
      ImageDestroy($targetImage);
    }
    else
    {
      // make thumbnail displaying standard 64x64 image icon
      $sourceImage = ImageCreateFromPng("gfx/imageFileIcon.png");

      $sourceWidth = ImageSX($sourceImage);
      $sourceHeight = ImageSY($sourceImage);

      $targetImage = ImageCreateTrueColor($targetWidth, $targetHeight);
      $targetFileName = $targetFileNameWithoutExtension .".png";

      $white = imagecolorallocate($targetImage, 255, 255, 255);
      ImageFilledRectangle($targetImage, 0, 0, $targetWidth - 1, $targetHeight - 1, $white);
      imagecolordeallocate($targetImage, $white);

      $targetCenterX = $targetWidth / 2;
      $targetCenterY = $targetHeight / 2;

      $targetX = $targetCenterX - $sourceWidth / 2;
      $targetY = $targetCenterY - $sourceHeight / 2;

      ImageCopy($targetImage,$sourceImage, $targetX, $targetY, 0, 0, $sourceWidth, $sourceHeight);

      ImageDestroy($sourceImage);

      @ImagePng($targetImage, $targetFileName);
      ImageDestroy($targetImage);
    }
    return $targetFileName;
  }

?>