<?php
  include_once("functions.php");
  
  // create site if it has not already been created
  if(!databaseTableCreated())
  {
    header("Location: create.php");
    die(); 
  }
  
  $selectedYear = $_POST["year"];
  if(!isset($selectedYear)) $selectedYear = date("Y");
?>
<?php print '<?xml version="1.0" encoding="UTF-8"?>'; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<link rel="stylesheet" href="style.css" type="text/css" />
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />
<title><?=_PAGE_TITLE?></title>
<link rel="icon" type="image/png" href="gfx/favicon.png" />
<script type="text/javascript" src="prototype.js"></script>
<script type="text/javascript">
  function toggleComment(id)
  {
    $('shortComment_' + id).toggleClassName('hidden');
    $('longComment_' + id).toggleClassName('hidden');
  }
</script>
</head>

<body id="indexBody">
<div id="indexWrapper">
<form method="post" action="<?=$_SERVER["PHP_SELF"]?>">

<div id="top">

  <div id="logo">
    <img src="gfx/book.png" alt="" />
  </div>

  <a href="rss.php"><img id="rssIcon" src="gfx/feed-icon-28x28.png" alt="<?=_RSS_FEED?>" /></a>

  <div id="intro">
  <h1><?=_CAPTION?></h1>
  <p><?=_INTRO?></p>
  
  
  

  <p id="selectYear">
  <? 
    $years = DataAccess::getYears();
    $years = array_reverse($years);
    
    if(count($years) == 0)
    {
      print _NO_MAPS;
    }
    else
    {
    ?>  
    <label for="year"><?=_SELECT_YEAR?>:</label>
    <select name="year" id="year" onchange="document.forms[0].submit();">
    <?
      foreach($years as $year)
      {
        print '<option value="'. $year .'"'. ($selectedYear == $year ? ' selected="selected"' : '') .'>'. $year .'</option>';
      }
    ?>
    </select>
  <? } ?>
  </p>
  </div>
  
</div>

<div id="maps">
<?

  $maps = DataAccess::getMaps(strtotime("$selectedYear-01-01"), strtotime("$selectedYear-12-31"));
  
  $width = THUMBNAIL_WIDTH;
  $height = THUMBNAIL_HEIGHT;

  foreach($maps as $map)
  {
    $url = ($map->MapImage ? 'show_map.php?id='. $map->ID : "");
    $name = $map->Name .' ('. date("Y-m-d", strtotime($map->Date)) .')';
    $image = '<img src="'. getThumbnailImage($map) .'" class="mapExtract" alt="'. htmlspecialchars($name)  .'" height="'. $height .'" width="'. $width .'" />';
    $linkedName = encapsulateLink($url, $map->Name); 
    $linkedImage = encapsulateLink($url, $image); 
?>
  <div class="map">
    <?=$linkedImage?>
    <div class="info">
      <div class="date">
        <?=dateToLongString(strtotime($map->Date))?>
      </div>
      <div class="name">
        <?=$linkedName?>
      </div>
      <? if(SHOW_MAP_NAME) { ?>
      <div class="mapName">
        <?=$map->MapName?>
      </div>
      <? } ?>
      <? if(SHOW_ORGANISER) { ?>
      <div class="organiser">
        <?=$map->Organiser?><? if(SHOW_COUNTRY && $map->Country) print ', '. $map->Country; ?>
      </div>
      <? } ?>
      <? if(SHOW_DISCIPLINE) { ?>
      <div class="discipline">
        <?=$map->Discipline?><? if(SHOW_RELAY_LEG && $map->RelayLeg) print ', '. _RELAY_LEG_LC .' '. $map->RelayLeg; ?>
      </div>
      <? } ?>
      <? if(SHOW_RESULT_LIST_URL && $map->CreateResultListUrl()) { ?>
      <div class="resultListUrl">
        <a href="<?=$map->CreateResultListUrl()?>"><?=_RESULTS?></a>
      </div>
      <? } ?>
      <? if(isLoggedIn()) { ?>
        <div class="admin">
          <?=$map->Views?> <?=_VIEWS?> | <a href="admin.php?id=<?=$map->ID?>"><?=_EDIT_MAP?></a>
        </div>
      <? } ?>
    </div>
    <div class="clear"></div>
    <? 
      if(SHOW_COMMENT) 
      {
        createComment($map);
      }
      ?>
  </div>
<?
  }
?>
 
</div>

<p id="disclaimer"><?=_DISCLAIMER?></p>
<p id="adminPanel">
  <a href="http://www.matstroeng.se/doma"><?=_DIGITAL_MAP_ARCHIVE?></a>, <?=_VERSION?> <?=VERSION_NUMBER?>
  |
<? if(!isLoggedIn()) { ?>
  <a href="login.php"><?=_LOGIN?></a>
<? } else { ?>
  <a href="admin.php"><?=_ADD_MAP?></a>
  |
  <a href="login.php?action=logout"><?=_LOGOUT?></a>
<? } ?>
</p>
<div class="clear"></div>

</form>
</div>
</body>
</html>

<?
  function createComment($map)
  {
    if(!$map->Comment) return;
    $maxLength = 140;
    
    if(strlen($map->Comment) <= $maxLength)
    {
      print '<div class="comment">'. $map->Comment .'</div>';
    }
    else
    {
      ?>
      <div class="comment" id="shortComment_<?=$map->ID?>">
        <img src="gfx/plus.png" class="button" onclick="toggleComment(<?=$map->ID?>);" />
        <div class="indent"><?=substr($map->Comment, 0, $maxLength)?>...</div>
      </div>
      <div class="comment hidden" id="longComment_<?=$map->ID?>">
        <img src="gfx/minus.png" class="button" onclick="toggleComment(<?=$map->ID?>);" />
        <div class="indent"><?=$map->Comment?></div>
      </div>
      <?
    }
  }
?>