<?php
  include_once("functions.php");
  include_once('nusoap.php');

  define("NAMESPACE", 'http://www.matstroeng.se/doma');

  $server = createServer();

  // Use the request to (try to) invoke the service
  $HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
  $server->service($HTTP_RAW_POST_DATA);

  function createServer()
  {
    // *************************************************************************************
    // create the server instance
    // *************************************************************************************
    $server = new soap_server();
    $server->xml_encoding = "UTF-8";
    $server->decode_utf8 = false;
    $server->configureWSDL('DigitalMapArchiveService', NAMESPACE);

    // *************************************************************************************
    // define complex types
    // *************************************************************************************
    $server->wsdl->addComplexType(
        'PublishMapRequest',
        'complexType',
        'struct',
        'all',
        '',
        array(
            'Username' => array('name' => 'Username', 'type' => 'xsd:string'),
            'Password' => array('name' => 'Password', 'type' => 'xsd:string'),
            'MapInfo' => array('name' => 'Map', 'type' => 'tns:MapInfo'),
        )
    );

    $server->wsdl->addComplexType(
        'PublishMapResponse',
        'complexType',
        'struct',
        'all',
        '',
        array(
            'Success' => array('name' => 'Success', 'type' => 'xsd:boolean'),
            'ErrorMessage' => array('name' => 'ErrorMessage', 'type' => 'xsd:string'),
            'URL' => array('name' => 'URL', 'type' => 'xsd:string')
        )
    );

    $server->wsdl->addComplexType(
        'GetAllMapsRequest',
        'complexType',
        'struct',
        'all',
        '',
        array()
    );

    $server->wsdl->addComplexType(
        'GetAllMapsResponse',
        'complexType',
        'struct',
        'all',
        '',
        array(
            'Maps' => array('name' => 'Maps', 'type' => 'tns:MapInfoArray')
        )
    );

    $server->wsdl->addComplexType(
        'ConnectRequest',
        'complexType',
        'struct',
        'all',
        '',
        array(
            'Username' => array('name' => 'Username', 'type' => 'xsd:string'),
            'Password' => array('name' => 'Password', 'type' => 'xsd:string')
        )
    );

    $server->wsdl->addComplexType(
        'ConnectResponse',
        'complexType',
        'struct',
        'all',
        '',
        array(
            'Success' => array('name' => 'Success', 'type' => 'xsd:boolean'),
            'ErrorMessage' => array('name' => 'ErrorMessage', 'type' => 'xsd:string')
        )
    );

    $server->wsdl->addComplexType(
        'MapInfo',
        'complexType',
        'struct',
        'all',
        '',
        array(
            'ID'=> array('name' => 'ID', 'type' => 'xsd:int'),
            'Date' => array('name' => 'Date', 'type' => 'xsd:dateTime'),
            'Name' => array('name' => 'Name', 'type' => 'xsd:string'),
            'Organiser' => array('name' => 'Organiser', 'type' => 'xsd:string'),
            'Country' => array('name' => 'Country', 'type' => 'xsd:string'),
            'Discipline' => array('name' => 'Discipline', 'type' => 'xsd:string'),
            'RelayLeg' => array('name' => 'RelayLeg', 'type' => 'xsd:string'),
            'MapName' => array('name' => 'MapName', 'type' => 'xsd:string'),
            'ResultListUrl' => array('name' => 'ResultListUrl', 'type' => 'xsd:string'),
            'Comment' => array('name' => 'Comment', 'type' => 'xsd:string'),
            'MapImageData' => array('name' => 'Image', 'type' => 'xsd:base64Binary'),
            'MapImageFileExtension' => array('name' => 'ImageFileExtension', 'type' => 'xsd:string')
        )
    );

    $server->wsdl->addComplexType(
        'MapInfoArray',
        'complexType',
        'array',
        '',
        'SOAP-ENC:Array',
        array(),
        array(
            array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:MapInfo[]')
        ),
        'tns:MapInfo'
    );


    // *************************************************************************************
    // register service methods
    // *************************************************************************************
    $server->register(
        'PublishMap',
        array('request' => 'tns:PublishMapRequest'),        // input parameters
        array('response' => 'tns:PublishMapResponse'),      // output parameters
        NAMESPACE
    );

    $server->register(
        'GetAllMaps',
        array('request' => 'tns:GetAllMapsRequest'),        // input parameters
        array('response' => 'tns:GetAllMapsResponse'),      // output parameters
        NAMESPACE
    );

    $server->register(
        'Connect',
        array('request' => 'tns:ConnectRequest'),        // input parameters
        array('response' => 'tns:ConnectResponse'),      // output parameters
        NAMESPACE
    );

    return $server;
  }

  // *************************************************************************************
  // service method implementations
  // *************************************************************************************
  function PublishMap($request)
  {
    $success = false;
    // validate username and password
    if(!validateUser($request["Username"], $request["Password"]))
    {
      $errorMessage = "Invalid username and/or password.";
    }
    else
    {
      $map = new Map();
      $map->ID = $request["MapInfo"]["ID"];
      $map->Date = $request["MapInfo"]["Date"];
      $map->Name = $request["MapInfo"]["Name"];
      $map->Organiser = $request["MapInfo"]["Organiser"];
      $map->Country = $request["MapInfo"]["Country"];
      $map->Discipline = $request["MapInfo"]["Discipline"];
      $map->RelayLeg = $request["MapInfo"]["RelayLeg"];
      $map->MapName = $request["MapInfo"]["MapName"];
      $map->ResultListUrl = $request["MapInfo"]["ResultListUrl"];
      $map->Comment = $request["MapInfo"]["Comment"];
      if(!$request["MapInfo"]["ID"]) $map->LastChangedTime = date("Y-m-d H:i:s");

      DataAccess::saveMap($map, $request["MapInfo"]["MapImageData"], $request["MapInfo"]["MapImageFileExtension"]);
      $errorMessage = mysql_error();
      $success = ($errorMessage == "");
      $url = getWebsiteUrl() ."/show_map.php?id=". $map->ID;
    }

    return array(
      'Success' => $success,
      'ErrorMessage' => $errorMessage,
      'URL' => $url
    );
  }

  function GetAllMaps()
  {
    $response = array();
    $response["Maps"] = array();

    $maps = DataAccess::getAllMaps();

    foreach($maps as $m)
    {
      $response["Maps"][] = array(
        "ID" => $m->ID,
        "Date" => date("c", strtotime($m->Date)),
        "Name" => $m->Name,
        "Organiser" => $m->Organiser,
        "Country" => $m->Country,
        "Discipline" => $m->Discipline,
        "RelayLeg" => $m->RelayLeg,
        "MapName" => $m->MapName,
        "ResultListUrl" => $m->ResultListUrl,
        "Comment" => $m->Comment
      );
    }
    return $response;
  }

  function Connect($request)
  {
    $success = validateUser($request["Username"], $request["Password"]);
    $errorMessage = "";
    if(!$success)
    {
      $errorMessage = "Invalid username and/or password.";
    }
    return array("Success" => $success, "ErrorMessage" => $errorMessage);
  }

?>